%% Le présent projet est en licence Crative Commons BY-NC-SA 3.0, Romuald THION.
%% Vous devez créditer l'oeuvre, vous n'êtes pas autorisé à faire un usage commercial de cette oeuvre,
%% tout ou partie du matériel la composant, dans le cas où vous effectuez un remix, que vous transformez,
%% ou créez à partir du matériel composant l'oeuvre originale, vous devez diffuser l'Oeuvre modifiée dans les même conditions.

%% https://creativecommons.org/licenses/by-nc-sa/3.0/fr/

%% The Tikz's is adapted from Arvid's tikz card template
%% https://tex.stackexchange.com/questions/47924/creating-playing-cards-using-tikz
%% https://tex.stackexchange.com/questions/243740/print-double-sided-playing-cards

\pgfmathsetmacro{\cardwidth}{6.35}%{6.35}%{5.715} %
%% width of card in cm. 5.715 = 2.25 in, 6.35 = 2.5 in
\pgfmathsetmacro{\cardheight}{8.875}
%% height of a card in cm. 8.875 = 3.5 in

\pgfmathsetmacro{\borderwidth}{0.3}%{0.0167*\cardwidth}%{0.1}
%% white border around the card

\pgfmathsetmacro{\imagewidth}{1*\cardwidth-2*\borderwidth}
\pgfmathsetmacro{\imageheight}{1*\cardheight-2*\borderwidth}
%% the image is AUTOMATICALLY RESIZED to fit the \imagewidth * \imageheight zone

%% ratio for poker-sized deck, with 3mm bleeding:
%%  w: 63.5-2*3 = 57.5
%%    in px : 680
%%  h: 88.9-2*3 = 82.9
%%    in px : 980 (300 dpi)
%%  w/h = 0.6936
%%  h/w = 1.4417 (~13/9, ie 3R photo format)

%% ratio for poker-sized deck, with 4mm bleeding:
%%  w: 63.5-2*4 = 55.5
%%    in px : 655.5
%%  h: 88.9-2*4 = 80.9
%%    in px : 955.5 (300 dpi)
%%  w/h = 0.686
%%  h/w = 1.4577

\pgfmathsetmacro{\stripwidth}{0.100*\cardwidth}%{0.7} % 0.12
%% strip is background for indices and title
\pgfmathsetmacro{\strippadding}{0.0333*\cardwidth}%{0.2}
%% padding around strips
\pgfmathsetmacro{\textpadding}{0.0167*\cardwidth}%{0.1} %0.0167
%% padding for text

\pgfmathsetmacro{\ratiocontent}{0.7}
%% % of vertical space used for content

\def\shapeCard{(0,0) rectangle (\cardwidth,\cardheight)}
%% main card (with rounded corners)
\def\shapeBackground{(\borderwidth,\borderwidth) rectangle (\cardwidth-\borderwidth,\cardheight-\borderwidth)}
%% main rectangle of cards, where the image is printed

\pgfmathsetmacro{\titley}{\strippadding+1*\stripwidth+\borderwidth}
%% vertical position of title : center of area
\pgfmathsetmacro{\titlex}{\stripwidth + 2*\strippadding + \borderwidth + \textpadding + 0.5*(\cardwidth-\stripwidth-3*\strippadding-2*\borderwidth-2*\textpadding)}
%% vertical position of title : center of area

\def\shapeTitle{(2*\strippadding+\stripwidth+\borderwidth,\strippadding+\borderwidth) rectangle (\cardwidth-\strippadding-\borderwidth,2*\stripwidth+\strippadding+\borderwidth)}
%% backgound zone for title

%% title (front)/date (back) : upper left to  lower right
\def\shapeContentArea{(2*\strippadding+\stripwidth+\borderwidth,\cardheight) rectangle (\cardwidth,\borderwidth + 1*\strippadding)}
%% \cardheight-\borderwidth-\ratiocontent*\cardheight
%% main text (back of the card), relative to cardheight and cardwidth to "cut" top and right rounded corners

\def\shapeStrip{(\strippadding+\borderwidth,\cardheight) rectangle (\strippadding+\stripwidth+\borderwidth,\strippadding+\borderwidth)}
%% vertical left long text

%% tickzset styles
\tikzset{
    cardcorners/.style={
            inner sep=0,
            outer sep=0,
            rounded corners=\strippadding *1cm %
            %% rounded corners of cards
        },
    elementcorners/.style={
            rounded corners= \textpadding *1cm % 0.1cm
            %% rounded corners of strips in the card
        },
    stripshadow/.style={
            drop shadow={
                    opacity=.2,
                    color=black
                }
            %% shadow for strips
        },
    strip/.style={
            elementcorners,
            %% stripshadow
            %% main style for strips
        },
    cardimage/.style={
            path picture={
                    \node at (0.5*\cardwidth,0.5*\cardheight) {
                        \includegraphics[height=\imageheight cm, width=\imagewidth cm]{#1}
                    };
                }
            %% main picture
        },
}

\newcommand{\carddebug}{
    \draw [step=0.25in,help lines] (0,0) grid (\cardwidth,\cardheight);
}
%% debug

\newcommand{\cardborder}{
    \draw[lightgray, cardcorners]  \shapeCard; %[lightgray, cardcorners] 
}
%% main card, with border

%% contour de la carte avec la date au dessus pour l'escape game
\newcommand{\cardEscapeBorderWithDate}[1]{
    \draw[gray, cardcorners]  \shapeCard;
    \draw[elementcorners, gray, fill=lightgray] (0,0) rectangle (\cardwidth, -2) node[black,pos=.5] {\huge#1};
}

\newcommand{\cardfrontbackground}[1]{
    \draw[lightgray,cardimage=#1] \shapeBackground;
}

%% main zone, where the image is printed
\newcommand{\cardbackbackground}[1]{
    \draw[lightgray,cardimage=#1, fill opacity=0.2] \shapeBackground;
}



%% Left strip of the card, with 256 rbg color (r, g, b args #1,2,3) and text (arg #3) written vertically
\newcommand{\cardtype}[4]{
    % The \clip command does not allow options, therefore  we have to use a scope to set the even odd rule.
    \begin{scope}[even odd rule]
        % Define a clipping path. All paths outside shapeCard will be cut because the even odd rule is set.
        \clip[cardcorners] \shapeBackground;
        % Since the even odd rule is set, only the card will be filled.
        \fill[strip,fill={rgb,255:red,#1;green,#2;blue,#3}] \shapeStrip (\strippadding+0.5*\stripwidth+\borderwidth,\cardheight-\borderwidth-\textpadding) node[rotate=90, left] {
            \color{white}\uppercase{#4}%
        };
    \end{scope}
}

%% Title (arg #1) of the card, written on shapeTitle
\newcommand{\cardtitle}[1]{
    \fill[elementcorners,titlebg,opacity=.85] \shapeTitle;
    \node[align=center, text width=(\cardwidth-\stripwidth-2*\strippadding-2*\borderwidth-2*\textpadding)*1cm] at (\titlex,\titley) {%
        \color{white}\sffamily\uppercase{#1}%
    };
}

%% Maincontent, written at the back: date (arg #1) and description (arg #2)
\newcommand{\cardcontent}[2]{
\begin{scope}[even odd rule]
    \clip \shapeBackground;
    \fill[elementcorners,contentbg,opacity=.5] \shapeContentArea;
\end{scope}
\node[below right, align=justify, text width=(\imagewidth-2*\strippadding-\stripwidth-2*\textpadding)*1cm] at (\borderwidth+2*\strippadding+\stripwidth+0*\textpadding,\cardheight-\textpadding-\borderwidth) {
\centerline{\sffamily\bf\Large #1}\\%
{\rmfamily\footnotesize #2}
};
}

%% Print vertical credits (arg #2) on a side (front). Text color (arg #1) is white by default
%% -0.105 shift so that the text is aligned along the border
\newcommand{\cardcredits}[2][white]{
    \node[rotate=90, left] at (\cardwidth-\borderwidth-0.105,\cardheight-\borderwidth) {
        {\color{#1}\tiny #2}
    };
}



